#!/usr/local/bin/perl

use strict;
use warnings;
use Mail::IMAPClient;
use DBI;
use POSIX;

## SACAR NOMBRE DE SERVIDOR MXC Y CON ELLO EL SERVIDOR DE RESTORES QUE USAREMOSW
our $servidor = `/bin/hostname | tr -d ' ' | tr -d '\n'`;
our $servidor_restores = "";
if ($servidor =~ /^mx1c.sarenet.es|^mx2c.sarenet.es|^mx3c.sarenet.es|^mx4c.sarenet.es|^mx5c.sarenet.es|^mx6c.sarenet.es/)
{
	$servidor_restores = "xx.xx.xx.xx";
}
elsif ($servidor =~ /^mx7c.sarenet.es|^mx8c.sarenet.es|^mx9c.sarenet.es|^mx10c.sarenet.es|^mx11c.sarenet.es|^mx12c.sarenet.es/)
{
	$servidor_restores = "yy.yy.yy.yy";
}
###############################################################################################################


######################################### ARRANCANDO ACCESOS A BBDD'S #########################################
our $mysql_server = $servidor_restores;
our $mysql_port = "3306";
our $databaser = "saremail_restore";
our $databaseu = "CORREO_Buzones";
our $usu_mysql = "xxxxxxxxxxxxxxx";
our $clave_mysql = "xxxxxxxxxxxx";
our $dsnr = "DBI:mysql:database=$databaser;host=$mysql_server;port=$mysql_port";
our $dbh0r = DBI->connect($dsnr, $usu_mysql, $clave_mysql) or die "Cant connect to the DB: $DBI::errstr\n";
our $dsnu = "DBI:mysql:database=$databaseu;host=$mysql_server;port=$mysql_port";
our $dbh0u = DBI->connect($dsnu, $usu_mysql, $clave_mysql) or die "Cant connect to the DB: $DBI::errstr\n";
######################################### ARRANCANDO ACCESOS A BBDD'S #########################################

our $verbose = '0';
our $option = "";

## FECHAS CALCULADAS EN BASE A MODO DE FUNCIONAMIENTO
our $fecha_hoy = "";
our $fecha_ayer = "";
our $fecha_antes_de_ayer = "";
our $fecha_en_jerarquia_srestore_modoayerohoraspronto = "";

## FECHAS REALES PARA TRABAJAR EN MODO AYER O EN HORAS 00, 01, 02, 03
our $hora_actual = `date '+%H' | tr -d ' ' | tr -d '\n'`;
our $modo = "";
our $dia_carpeta_o_uid = "";
our $diareal_hoy = `date '+%d' | tr -d ' ' | tr -d '\n'`;
our $diareal_ayer = `date -v-1d '+%d' | tr -d ' ' | tr -d '\n'`;
our $diareal_antesde = `date -v-2d '+%d' | tr -d ' ' | tr -d '\n'`;
our $fechareal_hoy = `date '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
our $fechareal_ayer = `date -v-1d '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
our $fechareal_antesde = `date -v-2d '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;

if ($ARGV[0] eq "hoy")
{
	$modo = "hoy";
	$fecha_hoy = `date '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
	$fecha_ayer = `date -v-1d '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
	## LA SIGUIENTE FECHA ES SOLO PARA COGER DE BBDD MESSAGE-ID
	$fecha_antes_de_ayer = `date -v-2d '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
}
elsif ($ARGV[0] eq "ayer")
{
	$modo = "ayer";
	$fecha_hoy = `date -v-1d '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
	$fecha_ayer = `date -v-2d '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
	## LA SIGUIENTE FECHA ES SOLO PARA COGER DE BBDD MESSAGE-ID
	$fecha_antes_de_ayer = `date -v-3d '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
}
else
{
	die "Necesito modo de ejecucion, hoy o ayer";
}

## DETERMINANDO EL MODO DE DEBUG EN EL QUE CORREMOS
if ($ARGV[1] eq "verbose")
{
	$verbose = '1';
	print "\n Archivar borrado de correo version 2.2 corriendo en modo verboso";	
}
elsif ($ARGV[1] eq "vverbose")
{
	$verbose = '2';
	print "\n Archivar borrado de correo version 2.2 corriendo en modo MUY verboso";		
}
else
{
	print "Archivar borrado de correo version 2.2 sin DEBUG";
}

########################################### VARIABLES DE LA MAIN ##############################################
my $buzon_cyrus_cyradm_procesando = "";
my @ids_recuperar = ();
our @array_subidos = ();
my $num_ids = '0';
my $id_actual = "";
my @array_email = "";
my $jerarquia = "";
my @array_jerarquia_deleted = "";
my $narray_jerarquia_deleted = '0';
my $jerarquia_sin_hex = "";
my $id_subida = "";
my @array_messageid_subidos_actual = ();
my $varchar_ids_subir = "";
my $varchar_ids_subir_duplicados = "";
my $path_fisico_disco = "";
my $ya_subido = '0';
my $dominio_temp = "";
my $message_id_a_subir = "";
my $buzon_restore_que_existe = "";
our $imap = "";
our @array_buzones = ();
our @array_messageid_subidos_actual_sin_duplicar = ();
my $validador = "";
########################################### VARIABLES DE LA MAIN ##############################################

sub refresca_expunged_buzones {
	my $linea = "";
	my $buzon_expunge = "";
	my $pid_proceso_borr = "";
	my $protocolo = "";
	my @array_linea = ();
	my $dominio = "";
	my $jerarquia_buzones = "";
	my $fecha_borrado = "";
	my $dia_linea = "";
	my $hora_correcta = "";
	my $hora_corte = '00';
	my $hora_linea = '00';
	my $leer_de_log = '0';
	my $servidorq = $dbh0r->quote($servidor);
	
	if (($modo eq "hoy") && (($hora_actual == '00') || ($hora_actual == '01') || ($hora_actual == '02') || ($hora_actual == '03') || ($hora_actual == '09')))
	{
		$hora_corte = '00';
	}
	elsif (($modo eq "hoy") && ($hora_actual > '03'))
	{
		$hora_corte = `date -v-3H '+%H' | tr -d ' ' | tr -d '\n'`;
	}
	## NO DEBERIA HACER FALTA LO SIGUIENTE PERO POR SI ACASO...
	else
	{
		$hora_corte = '00';
	}
	
	if ($modo eq "hoy")
	{
		open(FICHERO, "<", "/expert/htlogs/cyrus/imapd.log") or die "cannot open < $_[0]: $!";		
	}
	elsif ($modo eq "ayer")
	{
		open(FICHERO, "<", "/expert/htlogs/cyrus/imapd-ayer.log") or die "cannot open < $_[0]: $!";		
	}
	
    foreach $linea (<FICHERO>)  
    {
		 if ($linea =~ /^(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s{1,2}[0-9]{1,2}\s{1}(([0-9]{1,2}\:{1}){2}[0-9]{1,2}){1}\s{1}mx[0-9]{1,2}c\s{1}(pop3|imap)\[[0-9]+\]\:{1}\s+Expunged\s{1}[0-9]+\s{1}messages\s{1}from\s{1}(.*)\n{1}$/)
		 {
             ($buzon_expunge) = $linea =~ m/messages from (.+$)/;
			 ($protocolo)  = $linea =~ m/[0-9]+\s+mx[0-9]{1,2}c\s{1}(pop3|imap)\[/;
			 ($pid_proceso_borr) = $linea =~ m/\[{1}([0-9]+)\]{1}\:{1}\s{1}Expunged/;
			 ($fecha_borrado) = $linea =~ m/([A-Za-z]{3}\s{1,2}[0-9]{1,2}\s{1,2}[0-9]{1,2}\:{1}[0-9]{1,2}\:{1}[0-9]{1,2})\s{1}mx[0-9]{1,2}c/;
			 ($hora_linea) = $linea =~ m/[A-Za-z]{3}\s{1,2}[0-9]{1,2}\s{1,2}([0-9]{1,2})\:{1}[0-9]{1,2}\:{1}[0-9]{1,2}\s{1}mx[0-9]{1,2}c/;
 			 ($dia_linea) = $linea =~ m/[A-Za-z]{3}\s{1,2}([0-9]{1,2})\s{1,2}[0-9]{1,2}\:{1}[0-9]{1,2}\:{1}[0-9]{1,2}\s{1}mx[0-9]{1,2}c/;
			 if ((((($dia_linea == $diareal_hoy) && ($hora_linea >= $hora_corte)) || (($dia_linea == $diareal_ayer) && (($hora_actual == '00') || ($hora_actual == '01') || ($hora_actual == '02'))))))
			 {
				print "\nEmpezamos a trabajar con hora --$hora_linea-- en linea --$linea--" if ($verbose == '2');
			 	$leer_de_log = '1';
			 }
			 
			 if (($leer_de_log == '1') || ($modo eq "ayer"))
			 {
				 $hora_correcta = convertir_fecha($fecha_borrado);
				 @array_linea=split(/\!/,$buzon_expunge);
				 $dominio = $array_linea[0];
				 $jerarquia_buzones = $array_linea[1];
				 $jerarquia_buzones =~ s/\./\//g;
				 print "\n******************************************************************************************************************************************************************************************************************" if ($verbose == '2');
				 print "\nDel matcheo en servidor --$servidor-- sale : --$buzon_expunge-- que ordenado es --$jerarquia_buzones\@$dominio-- con protocolo --$protocolo-- borrado con pid numero --$pid_proceso_borr--" if ($verbose == '2');
				 my $usuarioq =  $dbh0r->quote("$jerarquia_buzones\@$dominio");
				 my $consulta00 = "INSERT INTO saremail_restore.log_leido (servidor, hora, proceso, pid, buzon) VALUES ("."$servidorq".", '"."$hora_correcta"."', '"."$protocolo"."' , '"."$pid_proceso_borr"."', "."$usuarioq".") ON DUPLICATE KEY UPDATE pid="."$pid_proceso_borr"."";
				 print "\nLa consulta que lanzamos en alta_usuario_buzon_restore vale ----$consulta00------\n" if ($verbose == '2');
				 print "\n******************************************************************************************************************************************************************************************************************" if ($verbose == '2');
				 my $sth0r =  $dbh0r->prepare("$consulta00");
				 $sth0r->execute();
				 $sth0r->finish();
			 }
			 elsif ($leer_de_log == '0')
			 {
				 print "\nIgnorando linea --$linea--" if (($verbose == '1')||($verbose == '2'));
			 }
		 }
	}
    close(FICHERO);
}

sub actualiza_estado_procesamiento_buzon {
	my @sacado_mysql_usuario = ();
	my @row = ();
	my $contador = '0';
	my $usuarioq = $dbh0r->quote($_[0]);
	my $servidorq = $dbh0r->quote($servidor);
	my $consulta00 = "";
	if ($modo eq "hoy")
	{
		my $tiempo_procesamiento_buzon = $_[1]/60;
		$tiempo_procesamiento_buzon = ceil($tiempo_procesamiento_buzon);
		print "\nSe han tardado --$tiempo_procesamiento_buzon-- minutos en procesar el buzon --$_[0]--";
		if ($tiempo_procesamiento_buzon < 5)
		{
			$tiempo_procesamiento_buzon = '5';
		}
		$consulta00 = "update saremail_restore.log_leido set procesado=1 where (servidor="."$servidorq"." AND buzon="."$usuarioq"." AND hora < DATE_SUB(NOW(), INTERVAL $tiempo_procesamiento_buzon MINUTE))";
		print "\nQUERY UPD --> --$consulta00--" if ($verbose == '2');
		my $sth0r = $dbh0r->prepare("$consulta00");
		$sth0r->execute();
		$sth0r->finish();
	}
	elsif ($modo eq "ayer")
	{
		## PARA QUE EN MODO AYER COMPLETE LO QUE QUEDE SIN PROCESAR...
		my $fecha_poner = `date -v-1d '+%Y-%m-%d%' | tr -d ' ' | tr -d '\n'`;
		my $fecha_ponerq = $dbh0r->quote($fecha_poner);
		$consulta00 = "update saremail_restore.log_leido set procesado=1 where (servidor="."$servidorq"." AND buzon="."$usuarioq"." AND hora like "."$fecha_ponerq".")";
		print "\nQUERY UPD --> --$consulta00--" if ($verbose == '2');
		my $sth0r = $dbh0r->prepare("$consulta00");
		$sth0r->execute();
		$sth0r->finish();
	}
}

sub convertir_fecha {
	my $mesnumero = '00';
	(my $hora) = $_[0] =~ m/\s+([0-9]{1,2}\:{1}[0-9]{1,2}\:{1}[0-9]{1,2})/;
	(my $mes) = $_[0] =~ m/(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)/;
	if ($mes eq "Jan")
	{
		$mesnumero = '01';
	}
	if ($mes eq "Feb")
	{
		$mesnumero = '02';
	}
	if ($mes eq "Mar")
	{
		$mesnumero = '03';
	}
	if ($mes eq "Apr")
	{
		$mesnumero = '04';
	}
	if ($mes eq "May")
	{
		$mesnumero = '05';
	}
	if ($mes eq "Jun")
	{
		$mesnumero = '06';
	}
	if ($mes eq "Jul")
	{
		$mesnumero = '07';
	}
	if ($mes eq "Aug")
	{
		$mesnumero = '08';
	}
	if ($mes eq "Sep")
	{
		$mesnumero = '09';
	}
	if ($mes eq "Oct")
	{
		$mesnumero = '10';
	}
	if ($mes eq "Nov")
	{
		$mesnumero = '11';
	}
	if ($mes eq "Dec")
	{
		$mesnumero = '12';
	}


	my $anio = `/bin/date '+%Y' | tr -d ' ' | tr -d '\n' | tr -d '\r'`;
	(my $dia) = $_[0] =~ m/([0-9]{1,2})\s+[0-9]{1,2}\:{1}[0-9]{1,2}\:{1}[0-9]{1,2}/;
	my $fecha_correcta = "$anio-$mesnumero-$dia $hora";
	print "\nDevuelvo --$fecha_correcta" if ($verbose == '2');
	return($fecha_correcta);
}

sub saca_expunges_de_bbdd {
	my @sacado_mysql_usuario = ();
	my @row = ();
	my $servidorq = $dbh0r->quote($servidor);
	my $consulta00 = "SELECT buzon from log_leido where servidor="."$servidorq"." AND procesado=0 ORDER by proceso='imap' DESC;";
	print "\nLa consulta lanzada dentro de la funcion comprobar_existencia_usuario_buzon_restore es : ---$consulta00---\n" if ($verbose == '2');
	my $sth0r = $dbh0r->prepare("$consulta00");
	$sth0r->execute();
	while (@row = $sth0r->fetchrow_array) 
    {
		push(@sacado_mysql_usuario,$row[0]); 
	}
	$sth0r->finish();
	return(@sacado_mysql_usuario);	
	
}

sub obtener_buzones_sobre_los_que_trabajar {
    print "FASE DE SACAR BUZONES SOBRE LOS QUE TRABAJAR";
    print "\n********************************************";
    ## SACAMOS LOS BUZONES QUE HAN SIDO BORRADOS Y LOS PONEMOS EN EL ARRAY
    my $comando = `/expert/binoff/saremail_restore/parsea_salida_expect.sh > /tmp/cyrus/buzones-cyradm`;
    my $linea = "";
    my @array_buzones = ();
    my @array_buzones_temp = ();		

    open(FICHERO, "<", "/tmp/cyrus/buzones-cyradm") or die "cannot open < /tmp/cyrus/buzones-cyradm: $!";
    foreach $linea (<FICHERO>)  
    {
        $linea =~ s/\n//g;
        $linea =~ s/\s+$//g;
        $linea =~ s/^\s+//g;            
		
		if ($verbose == '2')
		{
	        print "\n=========================================================================";
	        print "\nTratando la linea obtenida de buzones tipo DELETED ---$linea-----";
	        print "\n=========================================================================\n";
		}
        push(@array_buzones,$linea);
    }
    close(FICHERO);
	
	@array_buzones_temp = saca_expunges_de_bbdd();
    push(@array_buzones,@array_buzones_temp);	
	return(@array_buzones);
}

sub comprobar_sintaxis_buzon {
	my $validacion = '0';
	
	if ($_[0] =~ /DELETED\/user(\/{1}([a-zA-Z0-9]+[\.\-\_\^]?)+){1}(\/{1}[a-zA-Z0-9\:\'\=\,\.\;\&\+\-\ \_\^]+)*\@([a-zA-Z0-9]+([\.\-\_]?[a-zA-Z0-9]+)+)(\.{1}[a-zA-Z]+)+/)
 	{
		$validacion = '1';
	}
	elsif ($_[0] =~ /user(\/{1}([a-zA-Z0-9]+[\.\-\_\^]?)+){1}(\/{1}[a-zA-Z0-9\:\'\=\,\.\;\&\+\-\ \_\^]+)*\@([a-zA-Z0-9]+([\.\-\_]?[a-zA-Z0-9]+)+)(\.{1}[a-zA-Z]+)+/)
 	{
		$validacion = '1';
	}

        ## EXCEPTIONS I WANT TO BYPASS
        if ($_[0] =~ /mail\.xxxxx\.xxxxxx\.es/)
        {
                print "\nExcluyendo excepcion problematica ---$_[0]---\n";
                $validacion = '0';
        }
	
    return($validacion);
}

sub quitar_duplicados_array {
	my @array_del_que_quitar_duplicados = @_;
	my @array_sin_elementos_duplicados = ();
	my $elemento_actual = "";
	print "\nQuitando duplicados de un array generando otro..." if (($verbose == '1') || ($verbose == '2'));
	foreach $elemento_actual (@array_del_que_quitar_duplicados)
	{
		if (grep {$_ eq $elemento_actual} @array_sin_elementos_duplicados)
		{
			print "\nEl elemento ---$elemento_actual--- ya existe en el array sin duplicados. No hacemos PUSH" if ($verbose == '2');
			next;
		}
		else
		{
			print "\nEl elemento ---$elemento_actual--- NO existe en el array sin duplicados. Hacemos PUSH" if ($verbose == '2');
			push(@array_sin_elementos_duplicados,$elemento_actual);	
		}
	}
	return(@array_sin_elementos_duplicados);
}

sub obtener_messageids_subidos_buzon_cyrus {

	my @sacado_mysql_usuario = ();
	my @array_temporal = ();
	my $buzonq = $dbh0r->quote($_[0]);
	my $consulta00 = "";
	@array_subidos = (); 

	@sacado_mysql_usuario = ();
	@array_temporal = ();
	my $servidorq = $dbh0r->quote($servidor);
	$consulta00 = "SELECT messageids from tareas where buzon="."$buzonq"." AND fecha='$fecha_hoy' AND servidor="."$servidorq"." LIMIT 1";
	print "\nLa consulta lanzada dentro de la funcion obtener_messageids_subidos_buzon_cyrus es : ---$consulta00---\n" if ($verbose == '2');
	my $sth0r = $dbh0r->prepare("$consulta00");
	$sth0r->execute();
	@sacado_mysql_usuario = $sth0r->fetchrow_array;
	$sth0r->finish();	
	@array_temporal=split(/,/,$sacado_mysql_usuario[0]);
	push(@array_subidos,@array_temporal);

	@sacado_mysql_usuario = ();
	@array_temporal = ();
	$servidorq = $dbh0r->quote($servidor);
	$consulta00 = "SELECT messageids from tareas where buzon="."$buzonq"." AND fecha='$fecha_ayer' AND servidor="."$servidorq"." LIMIT 1";
	print "\nLa consulta lanzada dentro de la funcion obtener_messageids_subidos_buzon_cyrus es : ---$consulta00---\n" if ($verbose == '2');
	$sth0r = $dbh0r->prepare("$consulta00");
	$sth0r->execute();
	@sacado_mysql_usuario = $sth0r->fetchrow_array;
	$sth0r->finish();	
	@array_temporal=split(/,/,$sacado_mysql_usuario[0]);
	push(@array_subidos,@array_temporal);
	
	@sacado_mysql_usuario = ();
	@array_temporal = ();
	$servidorq = $dbh0r->quote($servidor);	
	$consulta00 = "SELECT messageids from tareas where buzon="."$buzonq"." AND fecha='$fecha_antes_de_ayer' AND servidor="."$servidorq"." LIMIT 1";
	print "\nLa consulta lanzada dentro de la funcion obtener_messageids_subidos_buzon_cyrus es : ---$consulta00---\n" if ($verbose == '2');
	$sth0r = $dbh0r->prepare("$consulta00");
	$sth0r->execute();
	@sacado_mysql_usuario = $sth0r->fetchrow_array;
	$sth0r->finish();	
	@array_temporal=split(/,/,$sacado_mysql_usuario[0]);
	push(@array_subidos,@array_temporal);

	return(@array_subidos);
}

sub comprobar_existencia_usuario_buzon_restore {
	my @sacado_mysql_usuario = ();
	my $emailq = $dbh0u->quote("$_[0]\@recuperaciones.saremail.com");
	my $servidorq = $dbh0u->quote($servidor);
	my $consulta00 = "SELECT email from usuarios where (email="."$emailq"." AND activo=1 AND servidor="."$servidorq".")";
	print "\nLa consulta lanzada dentro de la funcion comprobar_existencia_usuario_buzon_restore es : ---$consulta00---\n" if ($verbose == '2');
	my $sth0u = $dbh0u->prepare("$consulta00");
	my $valor_devolver = "";
	$sth0u->execute();
	@sacado_mysql_usuario = $sth0u->fetchrow_array;
	$sth0u->finish();
	if ($sacado_mysql_usuario[0] =~ /\@/)
 	{
		$valor_devolver = $sacado_mysql_usuario[0];
	}
	else
	{
		$valor_devolver = "";
	}
	print "\nLa funcion comprobar_existencia_usuario_buzon_restore devuelve ---$valor_devolver---\n" if ($verbose == '2');
	return($valor_devolver);	
}

sub alta_usuario_buzon_restore {
	my @sacado_mysql_usuario = ();
	my $usuarioq =  $dbh0u->quote($_[0]);
	my $servidorq = $dbh0u->quote($servidor);
	my $emailq =  $dbh0u->quote("$_[0]\@recuperaciones.saremail.com");
	my $consulta00 = "INSERT INTO usuarios (id, email, usuario, dominio, id_dominio, id_contrato, clave, cuota, maildrop, creado, modificado, activo, nombre, apellidos, departamento, antispam, antivirus, correo_externo, disclaimer, clave_orig, servidor) VALUES (NULL, "."$emailq".", "."$usuarioq".", 'recuperaciones.saremail.com', '7993', '', 'obUJMQu4QUAJY', '50000', '', '0000-00-00 00:00:00', NULL, '1', '', '', NULL, '0', '0', '1', '0', '', "."$servidorq".") ON DUPLICATE KEY UPDATE servidor="."$servidorq"."";
	print "\nLa consulta que lanzamos en alta_usuario_buzon_restore vale ----$consulta00------\n" if ($verbose == '2');
	my $sth0u =  $dbh0u->prepare("$consulta00");
	$sth0u->execute();
	$sth0u->finish();
}

sub sacar_message_id_correo_fichero {
	print "\n\nEn la funcion sacar_message_id_correo_fichero vamos a sacar el message-id del fichero ---$_[0]---\n\n" if ($verbose == '2');
	my $linea = "";
	my $message_id = "";
    open(FICHERO, "<", $_[0]) or die "cannot open < $_[0]: $!";
	foreach $linea (<FICHERO>)  
	{

		if ($linea =~ /^Message-Id: (<\S+>){1}/i)
		{
			($message_id) = $linea =~ m/(<\S+>){1}/;
			last;			
		} 

 
	}
	close(FICHERO);
	print "\nLa funcion sacar_message_id_correo_fichero devuelve : ---$message_id---\n" if ($verbose == '2');
	return($message_id);
}

sub actualizar_ids_subidos_a_buzon_cyrus {
	print "\nLos message-id que subimos a BBDD para ---$_[0]--- son : ---$_[1]---\n" if ($verbose == '2');
	my @sacado_mysql_usuario = ();
	my $messageids = $dbh0r->quote($_[1]);
	my $buzonq = $dbh0r->quote($_[0]);
	my $servidorq = $dbh0r->quote($servidor);	
	my $consulta00 = "INSERT INTO tareas (messageids,fecha,buzon,servidor) VALUES ("."$messageids".",'$_[2]',"."$buzonq".","."$servidorq".") ON DUPLICATE KEY UPDATE messageids="."$messageids"."";
	print "\nLa consulta que lanzamos dentro de actualizar_ids_subidos_a_buzon_cyrus vale--$consulta00--\n" if ($verbose == '2');	
	my $sth0r = $dbh0r->prepare("$consulta00");
	$sth0r->execute();
	$sth0r->finish();	
}

sub comprobar_id_subido_desde_bbdd {
	print "Comprobando si hemos subido el messageid arrobabarra buzonendestino : ---$_[0]---\n" if ($verbose == '2');
	if (grep {$_ eq $_[0]} @array_subidos)
	{
		print "\nDesde comprobar_id_subido_desde_bbdd devolvemos 0\n" if ($verbose == '2');
		return(0);
	}
	else
	{
		print "\nDesde comprobar_id_subido_desde_bbdd devolvemos 1\n" if ($verbose == '2');		
		return(1);		
	}
}

sub genera_fichero_unexpunge_ubicacion {
	print "\n-------------------------------------------------------------------";
	print "\n Se va a lanzar : --/usr/local/cyrus/bin/unexpunge -lv \"$_[0]\"--";
	print "\n-------------------------------------------------------------------";
	my $resultado_unexpunge = `/usr/local/cyrus/bin/unexpunge -lv \"$_[0]\"`;
	open (FICHEROTMPUB, '>', '/tmp/unexpunge-de-sitio');
	print FICHEROTMPUB $resultado_unexpunge;
	close FICHEROTMPUB;
}

sub genera_array_correos_unexpunge_ubicacion {
        my $resultado_unexpunge = `cat /tmp/unexpunge-de-sitio | grep UID | cut -d ':' -f2 | tr -d ' '`;
        my @array_unexpunge=split(/\n/,$resultado_unexpunge);
        return(@array_unexpunge);
}

sub ubicacion_en_disco_buzon_cyrus {
	my $ruta_disco_folder = `/usr/local/cyrus/bin/mbpath \"$_[0]\"`;
	return($ruta_disco_folder);
}

sub genera_array_correos_ls_ubicacion_deleted {
	print "\nSacando correos a subir en buzon tipo DELETED ---$_[0]---\n" if (($verbose == '1') || ($verbose == '2'));
	my $ids_dire_deleted = `ls \"$_[0]\" | egrep -v 'cyrus\.'`;
	my @arrays_ids_dire_deleted=split(/\n/,$ids_dire_deleted);
	return(@arrays_ids_dire_deleted);
}

sub saca_jerarquia_de_folder_destino {
	my $jerarquia_temp = "";
	if ($_[0] =~ /user\/[a-zA-Z0-9\.\-\_\^]+\/{1}([a-zA-Z0-9\,\.\;\&\+\-\ \_\/]+)\@/)
	{
		($jerarquia_temp) = $_[0] =~ m/user\/[a-zA-Z0-9\.\-\_\^]+\/{1}([a-zA-Z0-9\,\.\;\&\+\-\ \_\/]+)\@/;
	}
	else
	{
		$jerarquia_temp = "";
	}
	print  "\nLa jerarquia de la cuenta obtenida de ---$_[0]--- vale : ---$jerarquia_temp---\n";
	return($jerarquia_temp);
}

sub saca_jerarquia_imap_destino_de_buzon_cyrus_deleted {
	my $jerarquia = "";
	($jerarquia) = $_[0] =~ m/DELETED\/user\/[a-zA-Z0-9\.\-\_\^]+\/{1}([a-zA-Z0-9\,\.\;\&\+\-\ \_\/]+)\@/;
	print  "\nLa jerarquia del buzon tipo DELETED ---$_[0]--- vale : ---$jerarquia---\n";
	return($jerarquia);
}

sub saca_jerarquia_imap_destino_de_buzon_cyrus_deleted_sinhex {
	my @array_jerarquia_deleted=split(/\//,$_[0]);
	my $narray_jerarquia_deleted = scalar(@array_jerarquia_deleted);
	my $elem_actual = "";
	my $jerarquia_sin_hex = "";
	foreach $elem_actual (@array_jerarquia_deleted)
	{
		if ($narray_jerarquia_deleted > '1')
		{
			$jerarquia_sin_hex = $jerarquia_sin_hex."/".$elem_actual;
			$narray_jerarquia_deleted = $narray_jerarquia_deleted - 1;
		}
		elsif ($narray_jerarquia_deleted == '1')
		{
			print "\nLa jerarquia sin fecha hexadecimal vale del buzon deleted ---$_[0]--- vale ---$jerarquia_sin_hex----\n" if ($verbose == '2');
			last;
		}
	}
	
	if ($jerarquia_sin_hex eq "")
	{
		$jerarquia_sin_hex = "INBOX";
	}
	
	return($jerarquia_sin_hex);	
}

sub comprueba_si_existe_y_crea_en_imap_destino {
	my @array_jerarquia = split(/\//,$_[0]);
	my $elem_actual = "";
	my $acumulado = "";
	
	print "\nComprobando si ---$_[0]--- existe al completo. Para ello : \n" if ($verbose == '2');
	
	foreach $elem_actual (@array_jerarquia)
	{
		if ($acumulado ne "")
		{
			$acumulado = $acumulado."/".$elem_actual;
		}
		elsif ($acumulado eq "")
		{
			$acumulado = $elem_actual;
		}
		
		print "\nEl elemento actual acumulado de jerarquia vale : --$acumulado--\n" if ($verbose == '2');
		if (!$imap->exists($acumulado))
		{
			print "\nCreando/Subscribiendo buzon ---$acumulado---\n";
		   	$imap->create($acumulado) or die "Could not create en cuenta buzon recuperador $_[0]: $@\n";
			$imap->subscribe($acumulado) or die "Could not subscribe a carpeta de cuenta recuperador $_[0]: $@\n";
		}
		else
		{
			print "\nNO Creamos/Subscribimos al buzon ---$acumulado--- porque ya esta hecho.\n" if ($verbose == '2');
		}
	}
}

sub saca_fecha_expunge_buzon_DELETED {
	my $fecha_expunge = "";
	my $fecha_hex = "";
	my $dia = "";
	if ($_[0] =~ /DELETED\/user(\/{1}[a-zA-Z0-9\,\.\;\&\+\-\ \_\^]+)+\@[a-zA-Z0-9\.\-\_]+[a-zA-Z]{1}/)
	{
			($fecha_hex) = $_[0] =~ m/([0-9A-F]+)\@/;
			print "\nFecha hexadecimal vale ---$fecha_hex---" if ($verbose == '2');
			$fecha_expunge = scalar(localtime(hex("$fecha_hex")));
			print "\nFecha expunge ---$fecha_expunge---" if ($verbose == '2');
			($dia) = $fecha_expunge =~ m/[A-Za-z]+\s+[A-Za-z]+\s+([0-9]{1,2})\s+/;
	}
	return($dia);
}

sub saca_fecha_expunge_mensaje_hora_dudosa {
	my $id_mensaje = $_[1];
	my $comando = "cat /tmp/unexpunge-de-sitio | grep -A4 \"UID: $id_mensaje\" | grep \"Expg\" | awk \'\{print \$2\" \"\$3\" \"\$4\" \"\$5\}\' | tr -d '\\n'";
	print "El comando para sacar fecha expunge vale --$comando--" if ($verbose == '2');
	my $resultado_unexpunge = `$comando`;
	print "El resultado del comando para sacar fecha expunge vale --$resultado_unexpunge--" if ($verbose == '2');
	my ($dia) = $resultado_unexpunge =~ m/[A-Za-z]+\s+[A-Za-z]+\s+([0-9]{1,2})\s+/;
	return($dia);
}

sub saca_partes_email_de_buzon_cyrus {
	my $usuario = "";
	my $dominio = "";
	my @array_devolver = ();
	
	if ($_[0] =~ /DELETED\/user(\/{1}([a-zA-Z0-9]+[\.\-\_\^]?)+){1}(\/{1}[a-zA-Z0-9\:\'\=\,\.\;\&\+\-\ \_\^]+)*\@([a-zA-Z0-9]+([\.\-\_]?[a-zA-Z0-9]+)+)(\.{1}[a-zA-Z]+)+/)
 	{
			($usuario) = $_[0] =~ m/DELETED\/user\/([a-zA-Z0-9\.\-\_\^]+)/;
			($dominio) = $_[0] =~ m/(@[a-zA-Z0-9\.\-\_]+[a-zA-Z]{1})/;
			push(@array_devolver,$dominio);
			push(@array_devolver,$usuario);			
	}
	elsif ($_[0] =~ /user(\/{1}([a-zA-Z0-9]+[\.\-\_\^]?)+){1}(\/{1}[a-zA-Z0-9\:\'\=\,\.\;\&\+\-\ \_\^]+)*\@([a-zA-Z0-9]+([\.\-\_]?[a-zA-Z0-9]+)+)(\.{1}[a-zA-Z]+)+/)
 	{
			($usuario) = $_[0] =~ m/user\/([a-zA-Z0-9\.\-\_\^]+)/;
			($dominio) = $_[0] =~ m/(@[a-zA-Z0-9\.\-\_]+[a-zA-Z]{1})/;
			push(@array_devolver,$dominio);
			push(@array_devolver,$usuario);			
	}
	
	if (($usuario eq "") || ($dominio eq ""))
	{
		die("Fallo grave al obtener usuario --$usuario-- o --$dominio--");
	}
	
	return(@array_devolver);
}

###### FUNCION MAIN -- COMIENZA LA FIESTA!!!

refresca_expunged_buzones();
my @buzones_cyrus_cyradm = obtener_buzones_sobre_los_que_trabajar();
my @buzones_cyrus_cyradm_sin_repetir = quitar_duplicados_array(@buzones_cyrus_cyradm);
my $num_buzones_procesar = scalar(@buzones_cyrus_cyradm_sin_repetir);
my $num_buzones_totales = scalar(@buzones_cyrus_cyradm);
my $buzon_cyrus_cyradm_procesando_copia = "";
my $contador_progreso = '0';
my $warningprocesarbuzon = '0';
my $dia_real_temp = "";
my $timestamp_inicio_procesamiento = '0';
my $timestamp_fin_procesamiento = '0';
my $diferencia_timestamp = '0';

print "\nProcesando un numero de --$num_buzones_procesar-- de un total con repetidos de --$num_buzones_totales--";

$dbh0r->disconnect();
$dbh0u->disconnect();

foreach $buzon_cyrus_cyradm_procesando (@buzones_cyrus_cyradm_sin_repetir) {
        print "Procesando buzon ---$contador_progreso--- con nombre ---$buzon_cyrus_cyradm_procesando---\n" if ($verbose == '2');
        $contador_progreso = $contador_progreso + 1;
}
$contador_progreso = 0;

foreach $buzon_cyrus_cyradm_procesando (@buzones_cyrus_cyradm_sin_repetir) {
	$hora_actual = `date '+%H' | tr -d ' ' | tr -d '\n'`;
	$warningprocesarbuzon = '0';
	$dbh0r = DBI->connect($dsnr, $usu_mysql, $clave_mysql) or die "Cant connect to the DB: $DBI::errstr\n";
	$dbh0r->{mysql_auto_reconnect} = 1;
	$dbh0u = DBI->connect($dsnu, $usu_mysql, $clave_mysql) or die "Cant connect to the DB: $DBI::errstr\n";
	$dbh0u->{mysql_auto_reconnect} = 1;
	$validador = comprobar_sintaxis_buzon($buzon_cyrus_cyradm_procesando);
	$contador_progreso = $contador_progreso + 1;
	if ($validador != '1')
	{
		print "\n=========================================================================";
		print "\nError al validar buzon ---$buzon_cyrus_cyradm_procesando--- pasando de el";
		print "\n=========================================================================";
		next;
	}
	$buzon_cyrus_cyradm_procesando_copia = $buzon_cyrus_cyradm_procesando;
	## LO SIGUIENTE NO HACE FALTA CON LOS DE TIPO DELETED
	if ($buzon_cyrus_cyradm_procesando =~ /^user\//)
	{
		$buzon_cyrus_cyradm_procesando =~ s/\^/\./g;
	}
	print "\n************************************************************************************************************************************************\n";
	print "\nProcesando el buzon numero ---$contador_progreso---- de ----$num_buzones_procesar---- llamado ----$buzon_cyrus_cyradm_procesando---\n";
	print "\n************************************************************************************************************************************************\n";	
	@array_email = saca_partes_email_de_buzon_cyrus($buzon_cyrus_cyradm_procesando);
	$dominio_temp =	$array_email[0];
	$dominio_temp =~ s/\@//g;
	$buzon_restore_que_existe = comprobar_existencia_usuario_buzon_restore("$array_email[1]_$dominio_temp");
	print "\nComprobamos si crear el buzon o no... Para ello Buzon restore vale ---$buzon_restore_que_existe--- y ---$array_email[1]_$dominio_temp\@recuperaciones.saremail.com---\n" if ($verbose == '2');
	if ("$buzon_restore_que_existe" ne "$array_email[1]_$dominio_temp\@recuperaciones.saremail.com")
	{
		alta_usuario_buzon_restore("$array_email[1]_$dominio_temp");
	}
#	print "\n Conectando por IMAP a la cuenta --$array_email[1]_$dominio_temp\@recuperaciones.saremail.com-- al servidor $servidor_restores \n";
	$imap = Mail::IMAPClient->new(
	    Server   => $servidor_restores,
	    User     => "$array_email[1]_$dominio_temp\@recuperaciones.saremail.com",
	    Password => "XXXXXXXXXX",
		Peek	 => 1
		) or die "Cannot connect to IMAP";
	if ($buzon_cyrus_cyradm_procesando =~ /^user\//)
	{
		$timestamp_inicio_procesamiento = `date '+%s'`;
		@array_messageid_subidos_actual = ();
		@array_messageid_subidos_actual_sin_duplicar = ();
		genera_fichero_unexpunge_ubicacion($buzon_cyrus_cyradm_procesando);
		@ids_recuperar = genera_array_correos_unexpunge_ubicacion($buzon_cyrus_cyradm_procesando);
		$num_ids = scalar(@ids_recuperar);
		
		if ($num_ids > 0)
		{
			$path_fisico_disco = ubicacion_en_disco_buzon_cyrus($buzon_cyrus_cyradm_procesando);
			obtener_messageids_subidos_buzon_cyrus($buzon_cyrus_cyradm_procesando);
#### 			NO DEBERIA HACER FALTA			
####			comprueba_si_existe_y_crea_en_imap_destino($fecha_hoy);
			$jerarquia = saca_jerarquia_de_folder_destino($buzon_cyrus_cyradm_procesando);
			if ($jerarquia eq "")
			{
				$jerarquia = "INBOX";
			}
			if (($hora_actual != '00') && ($hora_actual != '01') && ($hora_actual != '02') && ($hora_actual != '03') && ($modo eq 'hoy'))
			{
				print "\nUsando manera optimizada de comprobar existencia por ser modo hoy y no horas dudosas." if (($verbose == '1') || ($verbose == '2'));
				comprueba_si_existe_y_crea_en_imap_destino($fecha_hoy."/".$jerarquia);
			}
			@array_messageid_subidos_actual = ();
			foreach $id_actual (@ids_recuperar) 
			{
				$id_actual =~ s/ //g;
				$id_actual =~ s/\n//g;
				$path_fisico_disco =~ s/\n//g;
				$message_id_a_subir = sacar_message_id_correo_fichero("$path_fisico_disco/$id_actual.");
				$ya_subido = comprobar_id_subido_desde_bbdd("$message_id_a_subir");
				if ($ya_subido == '1')
				{
					if ((((($hora_actual == '00') || ($hora_actual == '01') || ($hora_actual == '02') || ($hora_actual == '03')) && ($modo eq 'hoy'))) || ($modo eq 'ayer'))
					{
						## LA VARIABLE DIA_REAL_TEMP ES POR SI HE COMENZADO LA EJECUCION HOY POR EJ A LAS 23:58 Y SE ME HACE EL DIA SIGUIENTE
						$dia_real_temp = `date '+%d' | tr -d ' ' | tr -d '\n'`;
						$dia_carpeta_o_uid = saca_fecha_expunge_mensaje_hora_dudosa($buzon_cyrus_cyradm_procesando,$id_actual);
						if ($dia_carpeta_o_uid == $diareal_hoy)
						{
							$fecha_en_jerarquia_srestore_modoayerohoraspronto = $fechareal_hoy;
						}
						elsif ($dia_carpeta_o_uid == $diareal_ayer)
						{
							$fecha_en_jerarquia_srestore_modoayerohoraspronto = $fechareal_ayer;
						}
						elsif ($dia_carpeta_o_uid == $diareal_antesde)
						{
							$fecha_en_jerarquia_srestore_modoayerohoraspronto = $fechareal_antesde;
						}
						## COMPROBACION POR SI SE ME HA PASADO EL DIA
						elsif ($dia_carpeta_o_uid == $dia_real_temp)
						{
							$fecha_en_jerarquia_srestore_modoayerohoraspronto = `date '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
						}
						else
						{
							print "\nError!!!!!!! sacando fecha de UID ---$id_actual--- de --$buzon_cyrus_cyradm_procesando--. Fecha expunge sacada vale ---$dia_carpeta_o_uid---";
							$warningprocesarbuzon = '1';
							$fecha_en_jerarquia_srestore_modoayerohoraspronto = $fechareal_hoy;
							print "\nSubiendo mensaje con problema para identificar fecha expunged a dia de hoy por si acaso... Actuando en modo por si acaso...";
						}
						print "\n Procesando id con message-id ---$message_id_a_subir--- a recuperar de ---$buzon_cyrus_cyradm_procesando--- cuyo valor es ---$id_actual--- se sube a carpeta destino --$fecha_en_jerarquia_srestore_modoayerohoraspronto/$jerarquia-- y lo cogemos de $path_fisico_disco/$id_actual."."\n" if (($verbose == '1') || ($verbose == '2'));
						print "\n El ID --$id_actual-- NO esta subido. Subimos a ---$fecha_en_jerarquia_srestore_modoayerohoraspronto/$jerarquia--- el fichero ---$path_fisico_disco/$id_actual.---\n" if (($verbose == '1') || ($verbose == '2'));
						comprueba_si_existe_y_crea_en_imap_destino($fecha_en_jerarquia_srestore_modoayerohoraspronto."/".$jerarquia);
    					$id_subida = $imap->append_file($fecha_en_jerarquia_srestore_modoayerohoraspronto."/".$jerarquia, "$path_fisico_disco/$id_actual.") or die "Could not append_file: $@\n";
					}
					else
					{
						print "\n Procesando id con message-id ---$message_id_a_subir--- a recuperar de ---$buzon_cyrus_cyradm_procesando--- cuyo valor es ---$id_actual--- se sube a carpeta destino --$fecha_hoy/$jerarquia-- y lo cogemos de $path_fisico_disco/$id_actual."."\n" if (($verbose == '1') || ($verbose == '2'));						
						print "\n El ID --$id_actual-- NO esta subido. Subimos a ---$fecha_hoy/$jerarquia--- el fichero ---$path_fisico_disco/$id_actual.---\n" if (($verbose == '1') || ($verbose == '2'));
	    				$id_subida = $imap->append_file($fecha_hoy."/".$jerarquia, "$path_fisico_disco/$id_actual.") or die "Could not append_file: $@\n";
					}
				}
				else
				{
					print "\n El ID --$id_actual-- ya esta subido\n" if ($verbose == '2');
				}

				push(@array_messageid_subidos_actual,"$message_id_a_subir");

			}
			if ($warningprocesarbuzon == '1')
			{
				print "\nFuncionando en modo --$modo-- hay WARNINGS al tratar el buzon ---$buzon_cyrus_cyradm_procesando--- por no poder sacar donde hay que subir un id de mensaje anterior.";
			}
			$imap->disconnect or warn "Could not disconnect: $@\n";
			@array_messageid_subidos_actual_sin_duplicar = quitar_duplicados_array(@array_messageid_subidos_actual);
		    $varchar_ids_subir = join(',', @array_messageid_subidos_actual_sin_duplicar);
			$varchar_ids_subir_duplicados = join(',', @array_messageid_subidos_actual);
			print "\n Por ultimo subimos a BBDD que para --$buzon_cyrus_cyradm_procesando-- hemos subido los id --$varchar_ids_subir-- para dia de hoy en --$fecha_hoy--. Los message-id totales duplicados son :  --$varchar_ids_subir_duplicados--- \n";
			actualizar_ids_subidos_a_buzon_cyrus($buzon_cyrus_cyradm_procesando,$varchar_ids_subir,$fecha_hoy);
			$timestamp_fin_procesamiento = `date '+%s'`;
			$diferencia_timestamp = $timestamp_fin_procesamiento - $timestamp_inicio_procesamiento;
			actualiza_estado_procesamiento_buzon($buzon_cyrus_cyradm_procesando_copia,$diferencia_timestamp);
			
		}
		else
		{
			print "\n Nada a hacer unexpunge aqui \n";
			$timestamp_fin_procesamiento = `date '+%s'`;
			$diferencia_timestamp = $timestamp_fin_procesamiento - $timestamp_inicio_procesamiento;
			actualiza_estado_procesamiento_buzon($buzon_cyrus_cyradm_procesando_copia,$diferencia_timestamp);
		}
	}
	elsif ($buzon_cyrus_cyradm_procesando =~ /^DELETED\//)
	{
	#	## BUSCO SIEMPRE LA HORA DEL BORRADO CON EL HEXADECIMAL
		$timestamp_inicio_procesamiento = `date '+%s'`;
		@array_messageid_subidos_actual = ();
		@array_messageid_subidos_actual_sin_duplicar = ();
		$buzon_cyrus_cyradm_procesando_copia = $buzon_cyrus_cyradm_procesando;
		obtener_messageids_subidos_buzon_cyrus($buzon_cyrus_cyradm_procesando);
		$dia_carpeta_o_uid = saca_fecha_expunge_buzon_DELETED($buzon_cyrus_cyradm_procesando);
		print "El dia --$dia_carpeta_o_uid--" if ($verbose == '2');
		$dia_real_temp = `date '+%d' | tr -d ' ' | tr -d '\n'`;
		## LA VARIABLE DIA_REAL_TEMP ES POR SI HE COMENZADO LA EJECUCION HOY POR EJ A LAS 23:58 Y SE ME HACE EL DIA SIGUIENTE
		if ($dia_carpeta_o_uid == $diareal_hoy)
		{
			$fecha_en_jerarquia_srestore_modoayerohoraspronto = $fechareal_hoy;
			
		}
		elsif ($dia_carpeta_o_uid == $diareal_ayer)
		{
			$fecha_en_jerarquia_srestore_modoayerohoraspronto = $fechareal_ayer;
			
		}
		elsif ($dia_carpeta_o_uid == $diareal_antesde)
		{
			$fecha_en_jerarquia_srestore_modoayerohoraspronto = $fechareal_antesde;
			
		}
		## COMPROBACION POR SI SE ME HA PASADO EL DIA
		elsif ($dia_carpeta_o_uid == $dia_real_temp)
		{
			$fecha_en_jerarquia_srestore_modoayerohoraspronto = `date '+%d%m%Y' | tr -d ' ' | tr -d '\n'`;
		}
		else
		{
			print "Error sacando fecha de carpeta DELETED --$buzon_cyrus_cyradm_procesando--";
			$warningprocesarbuzon = '1';
			$fecha_en_jerarquia_srestore_modoayerohoraspronto = $fechareal_hoy;
			print "Subiendo buzon DELETED a fecha de HOY real por si acaso... WARNING EN BUZON DE TIPO DELETED";
		}
		
		$path_fisico_disco = ubicacion_en_disco_buzon_cyrus($buzon_cyrus_cyradm_procesando);
		$path_fisico_disco =~ s/\n//g;
		print "El fecha_en_jerarquia_srestore_modoayerohoraspronto vale --$fecha_en_jerarquia_srestore_modoayerohoraspronto--";
		comprueba_si_existe_y_crea_en_imap_destino($fecha_en_jerarquia_srestore_modoayerohoraspronto);
		@array_email = saca_partes_email_de_buzon_cyrus($buzon_cyrus_cyradm_procesando);
		$dominio_temp =	$array_email[0];
		$dominio_temp =~ s/\@//g;
		$jerarquia = saca_jerarquia_imap_destino_de_buzon_cyrus_deleted($buzon_cyrus_cyradm_procesando);
		$jerarquia_sin_hex = saca_jerarquia_imap_destino_de_buzon_cyrus_deleted_sinhex($jerarquia);
		@ids_recuperar = ();
		@ids_recuperar = genera_array_correos_ls_ubicacion_deleted($path_fisico_disco);
		comprueba_si_existe_y_crea_en_imap_destino($fecha_en_jerarquia_srestore_modoayerohoraspronto.$jerarquia_sin_hex);
		foreach $id_actual (@ids_recuperar) {
			print "\n-----Trabajando con ID ---$id_actual----\n" if ($verbose == '2');
			$id_actual =~ s/ //g;
			$id_actual =~ s/\n//g;
			$path_fisico_disco =~ s/\n//g;
			$message_id_a_subir = sacar_message_id_correo_fichero("$path_fisico_disco/$id_actual");
			$ya_subido = comprobar_id_subido_desde_bbdd("$message_id_a_subir");
			if ($ya_subido == '1')
			{
				print "\n Procesando id con message-id ---$message_id_a_subir--- a recuperar de ---$buzon_cyrus_cyradm_procesando--- cuyo valor es ---$id_actual--- se sube a carpeta destino --$fecha_en_jerarquia_srestore_modoayerohoraspronto"."$jerarquia_sin_hex-- y lo cogemos de $path_fisico_disco/$id_actual\n" if (($verbose == '1') || ($verbose == '2'));
				print "\n Subiendo ID --$id_actual-- de carpeta DELETED. Subimos a ---$fecha_en_jerarquia_srestore_modoayerohoraspronto"."$jerarquia_sin_hex--- el fichero ---$path_fisico_disco/$id_actual---\n" if (($verbose == '1') || ($verbose == '2'));
				$id_subida = $imap->append_file($fecha_en_jerarquia_srestore_modoayerohoraspronto.$jerarquia_sin_hex, $path_fisico_disco."/".$id_actual) or die "Could not append_file: $@\n";
			}
			else
			{
				print "\n El ID --$id_actual-- ya esta subido\n" if ($verbose == '2');
			}
			push(@array_messageid_subidos_actual,"$message_id_a_subir");
		}
		$imap->disconnect or warn "Could not disconnect: $@\n";
		@array_messageid_subidos_actual_sin_duplicar = quitar_duplicados_array(@array_messageid_subidos_actual);
	    $varchar_ids_subir = join(',', @array_messageid_subidos_actual_sin_duplicar);
		$varchar_ids_subir_duplicados = join(',', @array_messageid_subidos_actual);
		print "\n Por ultimo subimos a BBDD que para --$buzon_cyrus_cyradm_procesando-- hemos subido los id --$varchar_ids_subir-- para dia de carpeta DELETED que es --$fecha_en_jerarquia_srestore_modoayerohoraspronto--. Los message-id totales duplicados son :  --$varchar_ids_subir_duplicados--- \n";
		
		actualizar_ids_subidos_a_buzon_cyrus($buzon_cyrus_cyradm_procesando,$varchar_ids_subir,$fecha_en_jerarquia_srestore_modoayerohoraspronto);
		$timestamp_fin_procesamiento = `date '+%s'`;
		$diferencia_timestamp = $timestamp_fin_procesamiento - $timestamp_inicio_procesamiento;
		actualiza_estado_procesamiento_buzon($buzon_cyrus_cyradm_procesando_copia,$diferencia_timestamp);
	}
	$dbh0r->disconnect();
	$dbh0u->disconnect();
}
