#!/usr/local/bin/perl

use strict;
use warnings;
use Mail::IMAPClient;
use DBI;

######################################### ARRANCANDO ACCESOS A BBDD'S #########################################
our $mysql_server = "xxxx.xxxxx.xxxx.xxx";
our $mysql_port = "3306";
our $databaser = "saremail_restore";
our $databaseu = "CORREO_Buzones";
our $usu_mysql = "xxxxxxxxxxx";
our $clave_mysql = "xxxxxxxxxxx";
our $dsnr = "DBI:mysql:database=$databaser;host=$mysql_server;port=$mysql_port";
our $dbh0r = DBI->connect($dsnr, $usu_mysql, $clave_mysql) or die "Cant connect to the DB: $DBI::errstr\n";
our $dsnu = "DBI:mysql:database=$databaseu;host=$mysql_server;port=$mysql_port";
our $dbh0u = DBI->connect($dsnu, $usu_mysql, $clave_mysql) or die "Cant connect to the DB: $DBI::errstr\n";
######################################### ARRANCANDO ACCESOS A BBDD'S #########################################

our $imap = "";
our $fecha_borrar = "";
our $servidor = `/bin/hostname | tr -d ' ' | tr -d '\n'`;

sub comprueba_si_existe_y_borra_en_imap_destino {
	my $carpeta_actual = "";
	my @array_carpetas_existentes_en_usuario = $imap->folders;
	push(@array_carpetas_existentes_en_usuario,$_[0]);
	my @array_carpetas_que_me_interesan = ();
	my @array_carpetas_que_me_interesan_sindup = ();	
	my @partes_carpeta = ();
	my $dia = '00';
	my $mes = '00';
	my $anio = '00';
	my $fechamayor = "";
	my $buzon_actual = "";
	my @array_carpetas_que_me_interesan2 = "";
	my $regexp_comparar = "";

	## SACO LAS CARPETAS DEL RAIZ CON FORMATO DE FECHA PARA SU NOMBRE
	foreach $carpeta_actual (@array_carpetas_existentes_en_usuario) {
		@partes_carpeta = ();
		if ($carpeta_actual =~ /\//)
		{
			@partes_carpeta = split(/\//, $carpeta_actual);
			push(@array_carpetas_que_me_interesan,$partes_carpeta[0]);
		}
		elsif ($carpeta_actual =~ /^[0-9]+$/)
		{
			push(@array_carpetas_que_me_interesan,$carpeta_actual);
		}
	}	

	## VEO SI CORRESPONDE BORRAR O NO LA CARPETA. EN CASO DE QUE SI SACO TODAS LAS CARPETAS 
	## DE LA CUENTA PARA HACER EL DM DE LO QUE MATCHEO QUE ES LO QUE ME INTERESA	
	@array_carpetas_que_me_interesan_sindup = quitar_duplicados_array(@array_carpetas_que_me_interesan);
	foreach $carpeta_actual (@array_carpetas_que_me_interesan_sindup) {
		print "\nComprobando si ---$carpeta_actual--- ES ANTERIOR A ---$_[0]---";
		$fechamayor = devuelve_fecha_mayor($_[0],$carpeta_actual);
		if (($_[0] == $fechamayor) || ($fechamayor == '444'))
		{
			@array_carpetas_que_me_interesan2 = $imap->folders;
			foreach $buzon_actual (@array_carpetas_que_me_interesan2){
				$regexp_comparar = "^".$_[0];
				print "\nComprobando si ---$buzon_actual--- matchea con ---$regexp_comparar---";
				if ($buzon_actual =~ /^$regexp_comparar/)
				{
					print "\nEl buzon --$buzon_actual-- se va a borrar";
					$imap->delete($buzon_actual);
				}
			}
		}
	}
}

sub devuelve_fecha_mayor {
	my $fecha1 = $_[0];
	my $fecha2 = $_[1];
	my $dd1 = '00';
	my $dd2 = '00';
	my $mes1 = '00';
	my $mes2 = '00';	
	my $anio1 = '00';
	my $anio2 = '00';	
	
	($dd1) = $_[0] =~ m/^([0-9]{1,2})[0-9]{1,2}[0-9]{4}/;
	($dd2) = $_[1] =~ m/^([0-9]{1,2})[0-9]{1,2}[0-9]{4}/;	
	($mes1) = $_[0] =~ m/^[0-9]{1,2}([0-9]{1,2})[0-9]{4}/;
	($mes2) = $_[1] =~ m/^[0-9]{1,2}([0-9]{1,2})[0-9]{4}/;	
	($anio1) = $_[0] =~ m/^[0-9]{1,2}[0-9]{1,2}([0-9]{4})/;
	($anio2) = $_[1] =~ m/^[0-9]{1,2}[0-9]{1,2}([0-9]{4})/;
	
	#print "\nEl dia 0 vale ---$dd1--- y el 1 vale ---$dd2---";
	#print "\nEl mes 0 vale ---$mes1--- y el 1 vale ---$mes2---";
	#print "\nEl anio 0 vale ---$anio1--- y el 1 vale ---$anio2---";	
		
	if ($anio2 > $anio1)
	{
		return($_[1]);
	}
	elsif ($anio2 < $anio1)
	{
		return($_[0]);
	}

	if ($mes2 > $mes1)
	{
		return($_[1]);
	}
	elsif ($mes2 < $mes1)
	{
		return($_[0]);
	}
	
	if ($dd2 > $dd1)
	{
		return($_[1]);
	}
	elsif ($dd2 < $dd1)
	{
		return($_[0]);
	}
	return('444');
}

sub quitar_duplicados_array {
	my @array_del_que_quitar_duplicados = @_;
	my @array_sin_elementos_duplicados = ();
	my $elemento_actual = "";
	foreach $elemento_actual (@array_del_que_quitar_duplicados)
	{
		if (grep {$_ eq $elemento_actual} @array_sin_elementos_duplicados)
		{
			next;
		}
		else
		{
			push(@array_sin_elementos_duplicados,$elemento_actual);	
		}
	}
	return(@array_sin_elementos_duplicados);
}

sub limpieza_en_bbdd {
	my $servidorq = $dbh0r->quote($servidor);
	my $consulta00 = "DELETE FROM saremail_restore.log_leido where hora < DATE_SUB(NOW(), INTERVAL 5 DAY) AND servidor="."$servidorq"."";
	print "\nLanzando limpieza en BBDD --$consulta00--";
	my $sth0r = $dbh0r->prepare("$consulta00");
	$sth0r->execute();
	$sth0r->finish();	
    ##
	$consulta00 = "DELETE FROM saremail_restore.tareas where hora < DATE_SUB(NOW(), INTERVAL 5 DAY) AND servidor="."$servidorq"."";
	print "\nLanzando limpieza en BBDD --$consulta00--";
	$sth0r = $dbh0r->prepare("$consulta00");
	$sth0r->execute();
	$sth0r->finish();	
}

## FUNCION MAIN

my @sacado_mysql_usuario = ();
my $servidorq = $dbh0u->quote($servidor);
my $consulta00 = "SELECT email,retencion from usuarios where (activo=1 AND servidor="."$servidorq"." AND usuario!='cyrusadminuser')";
my $sth0u = $dbh0u->prepare("$consulta00");
my $valor_devolver = "";
my @row = ();
my $fecha_borrar_comando = "";
$sth0u->execute();

while (@row = $sth0u->fetchrow_array)
{
	$imap = Mail::IMAPClient->new(
	    Server   => "xxxx.xxxxx.xxxx.xxx",
	    User     => "$row[0]",
	    Password => "xxxxxxxxxxxxxxxx",
		Peek	 => 1
		) or die "Cannot connect to IMAP con la cuenta --$row[0]";
		
	$fecha_borrar_comando = "date -v-".$row[1]."d '+%d%m%Y' | tr -d ' ' | tr -d '\n'";
	$fecha_borrar = `$fecha_borrar_comando`;
	print "\nTrabajando con usuario ---$row[0]--- que tiene retencion ---$row[1]--- y por lo tanto nos movemos con fecha : ---$fecha_borrar---";
	comprueba_si_existe_y_borra_en_imap_destino($fecha_borrar);
	$imap->disconnect or warn "Could not disconnect usuario --$row[0]---: $@\n";
}

limpieza_en_bbdd();

$dbh0u->disconnect();
$dbh0r->disconnect();
